namespace ConsoleApp1
{
    internal class Program
    {
        public static void UnosPodataka(out int n, out int q, out int[] a)
        {
            int[] input = Array.ConvertAll(Console.ReadLine().Split(' '), int.Parse);
            n = input[0];
            q = input[1];

            a = Array.ConvertAll(Console.ReadLine().Split(' '), int.Parse);
        }

        static void Main(string[] args)
        {
            // Unos podataka
            UnosPodataka(out int n, out int q, out int[] a);

            // Prolazak kroz upite
            for (int i = 0; i < q; i++)
            {
                int[] input = Array.ConvertAll(Console.ReadLine().Split(' '), int.Parse);
                int l = input[0];
                int r = input[1];

                HashSet<int> set = new HashSet<int>();
                for (int j = l - 1; j < r; j++)
                {
                    set.Add(a[j]);
                }

                Console.WriteLine(set.Count);
            }
        }
    }
}